from datetime import datetime
from typing import List
from backtest.lib import AnalysisResult
from stock.interfaces import StockInterface
import pprint


class BacktestCandidate:
    def __init__(self, stock: StockInterface, date: datetime, analyses: List[AnalysisResult]):
        self.stock = stock
        self.date = date
        self.analyses = analyses

    def get_stock(self) -> StockInterface:
        return self.stock

    def get_date(self) -> datetime:
        return self.date

    def get_analyses(self) -> List[AnalysisResult]:
        return self.analyses

    def __str__(self) -> str:
        return pprint.pformat({
            "symbol": self.stock.get_symbol(),
            "showed in scan": self.date.strftime("%Y-%m-%d"),
            "analyses": self.analyses
        })

    def __repr__(self) -> str:
        return self.__str__()
